/*
    Парус 8 - Панели мониторинга - ТОиР - Прогнозирование технического состояния
    Панель мониторинга: Корневая панель прогнозирования технического состояния
*/

//---------------------
//Подключение библиотек
//---------------------

import React, { useState } from "react"; //Классы React
import { Box, Tabs, Tab } from "@mui/material"; //Интерфейсные компоненты
import { MODES, TabPanel } from "./eqs_tech_cond_forecast_lyaout"; //Вспомогательные компоненты и вёрстка
import { AdminTab } from "./admin_tab"; //Интерфейс администрирования
import { ForecastTab } from "./forecast_tab"; //Интерфейс прогнозирования

//---------
//Константы
//---------

//Стили
const STYLES = {
    TABS_CONTAINER_BOX: { borderBottom: 1, borderColor: "divider" }
};

//-----------
//Тело модуля
//-----------

//Корневая панель прогнозирования технического состояния
const EqsTechCondForecast = () => {
    //Собственное состояние
    const [mode, setMode] = useState(MODES.ADMIN);

    //При переключении закладки
    const handleTabChange = (e, newValue) => setMode(newValue);

    //Генерация содержимого
    return (
        <>
            <Box sx={STYLES.TABS_CONTAINER_BOX}>
                <Tabs value={mode} onChange={handleTabChange}>
                    <Tab label="Прогноз" value={MODES.FORECAST} />
                    <Tab label="Обучение" value={MODES.ADMIN} />
                </Tabs>
            </Box>
            <TabPanel mode={mode} value={MODES.FORECAST}>
                <ForecastTab />
            </TabPanel>
            <TabPanel mode={mode} value={MODES.ADMIN}>
                <AdminTab />
            </TabPanel>
        </>
    );
};

//----------------
//Интерфейс модуля
//----------------

export { EqsTechCondForecast };
