/*
    Парус 8 - Панели мониторинга - ТОиР - Прогнозирование технического состояния
    Корневая панель прогнозирования технического состояния: дополнительная разметка и вёрстка клиентских элементов
*/

//---------------------
//Подключение библиотек
//---------------------

import React from "react"; //Классы React
import PropTypes from "prop-types"; //Контроль свойств компонента
import { Box } from "@mui/material"; //Интерфейсные компоненты

//---------
//Константы
//---------

//Режимы работы панели
const MODES = {
    FORECAST: 1,
    ADMIN: 2
};

//Высота главного меню
const APP_BAR_HEIGHT = "64px";

//Высота закладок
const TABS_HEIGHT = "49px";

//Высота кнопки "Ещё"
const TABLE_MORE_HEIGHT = "49px";

//Высота фильтров таблицы
const TABLE_FILTERS_HEIGHT = "48px";

//Стиль скролов
const SCROLL_STYLES = {
    "&::-webkit-scrollbar": {
        height: "8px",
        width: "8px"
    },
    "&::-webkit-scrollbar-track": {
        borderRadius: "8px",
        backgroundColor: "#EBEBEB"
    },
    "&::-webkit-scrollbar-thumb": {
        borderRadius: "8px",
        backgroundColor: "#b4b4b4"
    },
    "&::-webkit-scrollbar-thumb:hover": {
        backgroundColor: "#808080"
    }
};

//-----------
//Тело модуля
//-----------

//Закладка
const TabPanel = ({ mode, value, children }) => <Box hidden={mode != value}>{children}</Box>;

//Контроль свойств - Закладка
TabPanel.propTypes = {
    mode: PropTypes.number.isRequired,
    value: PropTypes.number.isRequired,
    children: PropTypes.element
};

//----------------
//Интерфейс модуля
//----------------

export { MODES, APP_BAR_HEIGHT, TABS_HEIGHT, TABLE_MORE_HEIGHT, TABLE_FILTERS_HEIGHT, SCROLL_STYLES, TabPanel };
